<template>
  <app-form title="Edit Board" :open="open" @close="cancelEdit">
    <form-group labelFor="form-edit-board-name" label="Board Name">
      <form-input
        id="form-edit-board-name"
        v-model="name"
        placeholder="Please Provide the name of the board..."
      ></form-input>
    </form-group>
    <template v-slot:footer>
      <button @click="editBoard" type="button" class="btn btn-primary">
        Rename
      </button>
      <button @click="cancelEdit" type="button" class="btn btn-light">
        Cancel
      </button>
    </template>
  </app-form>
</template>

<script lang="ts">
import { Board } from "@/core/database";
import { defineComponent, PropType } from "vue";
import AppForm from "../components/Form.vue";
import FormGroup from "../components/FormGroup.vue";
import FormInput from "../components/FormInput.vue";

export default defineComponent({
  components: { AppForm, FormGroup, FormInput },
  props: {
    open: {
      type: Boolean,
      required: true,
    },
    board: {
      type: Object as PropType<Board>,
      required: true,
    },
  },
  created() {
    this.name = this.board.name;
  },
  data() {
    return {
      name: "",
    };
  },
  methods: {
    editBoard() {
      const editedBoard = new Board(this.board.id, this.name);
      this.$emit("rename", editedBoard);
      this.cancelEdit();
    },
    cancelEdit() {
      this.$emit("cancel");
    },
  },
});
</script>
